package seminar13.solid5;

// Porušen Liskov substitution principle, chybná aplikace dědičnosti - nahradíme samostatnými rozhraními

import seminar13.solid2.FileLogger;

public class Customer implements IDiscount, IDatabase
{
   private final FileLogger logger = new FileLogger();
   @Override
   public void add()
   {
       try
       {
           // Database code goes here
       }
       catch (Exception ex)
       {
           logger.handle(ex.toString());
       }
   }

   @Override
   public double getDiscount(double totalSales)
   {
       return totalSales;
   }
}

class Enquiry implements IDiscount
{
    @Override
    public  double getDiscount(double totalSales)
    {
        return totalSales - 5;
    }
}

interface IDiscount
{
    double getDiscount(double totalSales);
}


interface IDatabase
{
    void add();
}